<template>
  <q-dialog
    ref="dialog"
    @hide="onDialogHide"
  >
    <q-card
      style="width: 98%;"
      class="q-dialog-plugin column"
    >
      <q-card-section
        class="q-pt-lg q-px-lg q-pb-none col-auto"
      >
        <p
          class="q-pa-none"
        >
          <q-icon
            name="las la-exclamation-circle"
            class="q-pr-xs"
            style="margin-top: -2px"
          />
          <translate :translate-params="{ iacsName: iacsName, iacsShortName: iacsShortName}">
            You session is expired: you must login again with %{iacsName} (%{iacsShortName}).
          </translate>
        </p>
        <p class="q-pa-none">
          <translate>The button below will open a new browser window: after successfully logging in, close the window and click on Ok.</translate>
        </p>
        <p class="text-center">
          <q-btn
            @click="onClickLinkRefreshIacsToken"
            color="primary"
            size="md"
            flat
          >
            <translate :translate-params="{ iacsShortName: iacsShortName}">
              Login with %{iacsShortName}
            </translate>
          </q-btn>
        </p>
      </q-card-section>

      <q-card-section>
        <q-card-actions align="around">
          <q-btn
            @click="onCancelClick"
            size="md"
            flat
          >
            <translate>Cancel</translate>
          </q-btn>
          <q-btn
            @click="onOKClick"
            color="primary"
            size="md"
            flat
          >
            <translate>Ok</translate>
          </q-btn>
        </q-card-actions>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { Browser } from '@capacitor/browser'

export default {
  name: 'RefreshIacsTokenDialog',
  props: {
    iacsName: {
      type: String,
      required: true
    },
    iacsShortName: {
      type: String,
      required: true
    },
    iacsRefreshTokenUrl: {
      type: String,
      required: true
    }
  },
  emits: [
    'ok', 'hide'
  ],
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    onDialogHide () {
      this.$emit('hide')
    },
    onOKClick () {
      this.$emit('ok')
      this.hide()
    },
    onCancelClick () {
      this.hide()
    },
    onClickLinkRefreshIacsToken () {
      if (this.isMobileApp) {
        Browser.open({ url: this.iacsRefreshTokenUrl })
      } else {
        window.open(this.iacsRefreshTokenUrl, '_blank')
      }
    }
  }
}
</script>
